#ifdef DEBUG
#ifndef __DEBUG_CPP
#define __DEBUG_CPP

#include "calculator.cpp"
#include "cursor.cpp"

/**
 * @brief Prints value of pressed key in top left corner.
 * Additionally it can get offet to see more presses.
 * 
 * @param _key char that we got.
 */
void debugKey(cursor::key _key) {
    static unsigned short offset = 0;
    cursor::savePosition();
    cursor::setPosition(1, 1);
    // std::cout << "      ";       // clear debug corner :^)
    cursor::setPosition(offset++ * 4 + 1, 1);
    std::cout << "\033[31;1m";
    // if control flag set
    if (_key.special != 0)
        std::cout << "^";
    std::cout << int(_key.code);
    std::cout << "\033[0m";
    cursor::restorePosition();
}

/**
 * @brief Prints the content of _input.
 * 
 * @param _input vector of symbols
 */
void dbgPrint(const std::vector<Calculator::Symbol>* _input) {
    for (auto it = _input->begin(); it != _input->end(); it++) {
        auto type = it->type;

        std::cout << "[";
        if (type == Calculator::SymbolType::add) std::cout << "+";
        else if (type == Calculator::SymbolType::subract) std::cout << "-";
        else if (type == Calculator::SymbolType::divide) std::cout << "/";
        else if (type == Calculator::SymbolType::multiply) std::cout << "*";
        else if (type == Calculator::SymbolType::number) std::cout << it->value;
        else if (type == Calculator::SymbolType::left_bracket) std::cout << "(";
        else if (type == Calculator::SymbolType::right_bracket) std::cout << ")";

        std::cout << "]";
    };
}

/**
 * @brief Prints the content of _input.
 * 
 * @param _input vetcor of unsigned int
 */
void dbgPrint(const std::vector<unsigned int>* _input) {
    for (auto it = _input->begin(); it != _input->end(); it++) {
        std::cout << "[" << *it << "]";
    }
}

#endif
#endif