#ifndef __UTILS_CPP
#define __UTILS_CPP

#include <iomanip>
#include <sstream>
#include <limits>

/**
 * @brief converts double to string
 * 
 * @param from the double to convert 
 * @param precision what precision the stringed version should be
 * @return std::string the converted number
 */
std::string doubleToString(const double& from, const int& precision = 10) {
    std::stringstream theStream;
    if (precision < 0) theStream << std::setprecision(std::numeric_limits<double>::digits10+1);
    else theStream << std::setprecision(precision);
    theStream  << from;
    return theStream.str();
}

#endif
